//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiAlerte {

    /** Permet de récupérer une alerte de sécurité dans le voisinage */
    public enum GetApiAlerteGetAlerte {

        public static let service = APIService<Response>(id: "getApiAlerteGetAlerte", tag: "Api Alerte", method: "GET", path: "/apiAlerte/getAlerte", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var idAlerte: String

                public init(idAlerte: String) {
                    self.idAlerte = idAlerte
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: GetApiAlerteGetAlerte.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(idAlerte: String) {
                let options = Options(idAlerte: idAlerte)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["idAlerte"] = options.idAlerte
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = [Alerte]

            /** Succes */
            case status200([Alerte])

            public var success: [Alerte]? {
                switch self {
                case .status200(let response): return response
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
